#***********************************************************************
#         Berliner Uhr
#         ============
#       Uwe Berger; 2009
#
# Eine Tcl/Tk-Version.
#
# Have fun!
#***********************************************************************

set gvar(dx) 170
set gvar(border) 3

set gvar(color_off) gray8
set gvar(color_hour) red
set gvar(color_minute) yellow
set gvar(color_second) yellow

#***********************************************************************
proc gui_init {} {
	global gvar

	set gvar(dy) $gvar(dx)
	set line_dy [expr $gvar(dy)/5]
	set line_dy_half [expr $line_dy / 2]
	set e_dy [expr ($line_dy / 2) - $gvar(border)]

	wm title . "Berliner Uhr" 
	wm resizable . 0 0
	canvas	.clock -width $gvar(dx) -height $gvar(dy) -bg black -bd 0
	pack .clock 

	# eine Sekundenanzeige
	.clock create oval	[expr ($gvar(dx) / 2) - $e_dy]\
							[expr $line_dy_half - $e_dy]\
							[expr ($gvar(dx) / 2) + $e_dy]\
							[expr $line_dy_half + $e_dy]\
							-outline $gvar(color_off) -fill $gvar(color_off)\
							-tags sec
	# vier Stunden 5er
	set line_dy_half [expr $line_dy_half + $line_dy]
	set dx [expr $gvar(dx) / 4]
	for {set i 0} {$i < 4} {incr i} {
	.clock create rectangle	[expr ($dx * $i) + $gvar(border)]\
							[expr $line_dy_half - $e_dy]\
							[expr ($dx * ($i + 1)) - $gvar(border)]\
							[expr $line_dy_half + $e_dy]\
							-outline $gvar(color_off) -fill $gvar(color_off)\
							-tags h5_$i
	}
	# vier Stunden 1er
	set line_dy_half [expr $line_dy_half + $line_dy]
	set dx [expr $gvar(dx) / 4]
	for {set i 0} {$i < 4} {incr i} {
	.clock create rectangle	[expr ($dx * $i) + $gvar(border)]\
							[expr $line_dy_half - $e_dy]\
							[expr ($dx * ($i + 1)) - $gvar(border)]\
							[expr $line_dy_half + $e_dy]\
							-outline $gvar(color_off) -fill $gvar(color_off)\
							-tags h1_$i
	}
	# elf Minuten 5er
	set line_dy_half [expr $line_dy_half + $line_dy]
	set dx [expr $gvar(dx) / 11]
	for {set i 0} {$i < 11} {incr i} {
	.clock create rectangle	[expr ($dx * $i) + $gvar(border)]\
							[expr $line_dy_half - $e_dy]\
							[expr ($dx * ($i + 1)) - $gvar(border)]\
							[expr $line_dy_half + $e_dy]\
							-outline $gvar(color_off) -fill $gvar(color_off)\
							-tags m5_$i
	}
	# vier Minuten 1er
	set line_dy_half [expr $line_dy_half + $line_dy]
	set dx [expr $gvar(dx) / 4]
	for {set i 0} {$i < 4} {incr i} {
	.clock create rectangle	[expr ($dx * $i) + $gvar(border)]\
							[expr $line_dy_half - $e_dy]\
							[expr ($dx * ($i + 1)) - $gvar(border)]\
							[expr $line_dy_half + $e_dy]\
							-outline $gvar(color_off) -fill $gvar(color_off)\
							-tags m1_$i
	}
}

#****************************************************************************
proc takt {} {
	global gvar
	# Uhrzeit ermitteln
	set s [scan [clock format [clock seconds] -format %S] %d]
	set m [scan [clock format [clock seconds] -format %M] %d]
	set h [scan [clock format [clock seconds] -format %H] %d]
	# Sekundentakt
	if {[expr $s % 2]} {.clock itemconfigure sec -fill $gvar(color_off) -outline $gvar(color_off)} \
	else {.clock itemconfigure sec -fill $gvar(color_second) -outline $gvar(color_second)} 
	# Sonderregelung für 24:00 Uhr
	if {($h == 0)&&($m == 0)} {set h 24}
	# 5er Stunden
	for {set i 0} {$i < 4} {incr i} {
		if {[expr $h / (($i + 1) * 5)]} {.clock itemconfigure h5_$i -fill $gvar(color_hour) -outline $gvar(color_hour)}\
		else {.clock itemconfigure h5_$i -fill $gvar(color_off) -outline $gvar(color_off)}
	}
	# 1er Stunden 		if (hh%5 > i) 
	for {set i 0} {$i < 4} {incr i} {
		if {[expr $h % 5] > $i} {.clock itemconfigure h1_$i -fill $gvar(color_hour) -outline $gvar(color_hour)}\
		else {.clock itemconfigure h1_$i -fill $gvar(color_off) -outline $gvar(color_off)}
	}
	# 5er Minuten
	for {set i 0} {$i < 11} {incr i} {
		if {[expr $m / (($i + 1) * 5)]} {
			# jede 3.Stelle wird farblich gekennzeichnet
			if {[expr ($i + 1) % 3]} {
			.clock itemconfigure m5_$i -fill $gvar(color_minute) -outline $gvar(color_minute)}\
			else {.clock itemconfigure m5_$i -fill $gvar(color_hour) -outline $gvar(color_hour)}}\
		else {.clock itemconfigure m5_$i -fill $gvar(color_off) -outline $gvar(color_off)}
	}
	# 1er Minuten
	for {set i 0} {$i < 4} {incr i} {
		if {[expr $m % 5] > $i} {.clock itemconfigure m1_$i -fill $gvar(color_minute) -outline $gvar(color_minute)}\
		else {.clock itemconfigure m1_$i -fill $gvar(color_off) -outline $gvar(color_off)}
	}
	after 1000 takt
}

#****************************************************************************
#****************************************************************************
#****************************************************************************
gui_init
takt

